freeslot("sfx_djump", "SPR_PEEL")
sfxinfo[sfx_djump].caption = "Double Jump"


rawset(_G, "P_IsPlayerMomentum", function(player)
	local skin = player.mo.skin
	if skin == "scribble"
		return true
	else
		return false
	end
end)

-----------------------------------------

addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "scribble")
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and not (player.powers[pw_super])
		   player.mo.state = S_PLAY_SPRING
		   S_StartSound(player.mo, sfx_djump)
	       P_SetObjectMomZ(player.mo, 14*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and (player.powers[pw_super])
		   S_StartSound(player.mo, sfx_djump)
		   P_SetObjectMomZ(player.mo, 17*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end   
	end	
end)

addHook("SpinSpecial", function(player)
    if (player.mo.skin == "scribble")
		if (player.mo.state == S_PLAY_SPRING)
		or (player.mo.state == S_PLAY_FALL)
		and (player.pflags & PF_THOKKED)
		and not (player.powers[pw_super])
		   S_StartSound(player.mo, sfx_spin)
		   P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_ROLL
		   player.pflags = $1|PF_THOKKED
		end
	end
end)

addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "scribble")
    and (player.mo.state == S_PLAY_ROLL)
        return true
    end
end)

addHook("PlayerThink", function(player)
    if not P_IsPlayerMomentum(player) return end
    if (player.speed >= skins[player.mo.skin].runspeed)
	and (player.cmd.forwardmove or player.cmd.sidemove)
		player.mo.friction = FRACUNIT
		player.charflags = $ & ~SF_NOSKID
	else
		player.mo.friction = 29*FRACUNIT/32
		player.charflags = $ & ~SF_NOSKID
	end
end)

addHook("PlayerThink", function(p)
	if (p.mo.skin == "scribble")
	and (p.pflags & PF_SPINNING)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player and player.mo and player.mo.valid) and (player.mo.skin == "scribble")
			if player.mo.state == S_PLAY_DASH
			and not player.powers[pw_super]
				for i = -40, 40
					
					local force = i*FRACUNIT/3
					local angle = ANGLE_90

					local shiftx = FixedMul(cos(player.drawangle + angle), force)
					local shifty = FixedMul(sin(player.drawangle + angle), force)
					
					local shiftx2 = FixedMul(cos(player.drawangle), FRACUNIT)
					local shifty2 = FixedMul(sin(player.drawangle), FRACUNIT)
					
					if i > 20
					or i < -20
						local peelout = P_SpawnMobjFromMobj(player.mo, shiftx2 + shiftx, shifty2 + shifty, 0, MT_OVERLAY)
						peelout.target = player.mo
						peelout.fuse = 1
						peelout.sprite = SPR_PEEL
						if i < 0
							if player.mo.frame == A
								peelout.frame = A
							elseif player.mo.frame == B
								peelout.frame = B
							elseif player.mo.frame == C
								peelout.frame = C
							elseif player.mo.frame == D
								peelout.frame = D
							end
							peelout.angle = player.drawangle + ANGLE_90/6
						else
							if player.mo.frame == A
								peelout.frame = C
							elseif player.mo.frame == B
								peelout.frame = D
							elseif player.mo.frame == C
								peelout.frame = A
							elseif player.mo.frame == D
								peelout.frame = B
							end
							peelout.angle = player.drawangle - ANGLE_90/6
						end
						peelout.renderflags = RF_PAPERSPRITE
						peelout.scale = player.mo.scale/2
						if player.mo.eflags & MFE_VERTICALFLIP
							peelout.eflags = $ | MFE_VERTICALFLIP
							peelout.z = player.mo.z + player.mo.height - peelout.height
						end
					end
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
    if (player.mo.skin == "scribble")
		if (player.mo.state == S_PLAY_RUN) 
		and (player.speed >= 50*FRACUNIT)
		and not (player.powers[pw_super])
		   player.mo.state = S_PLAY_DASH
		end
	end
end)

addHook("PlayerThink", function(player)
    if (player.mo.skin == "scribble")
		if (player.mo.state == S_PLAY_DASH) 
		and not (player.speed >= 50*FRACUNIT)
        and not (player.powers[pw_super])
		   player.mo.state = S_PLAY_RUN
		end
	end
end)